﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

namespace CSharp_DHHalLib_Wrapper_App
{
    class SPITest
    {
        public static void Testcode()
        {
            SPI_WriteLoopbackTest();
        }

        private static void SPI_WriteLoopbackTest()
        {
            uint freq = 1000000;        // 1 Mhz Clockrate
            UInt32[] inBuffer = new UInt32[3];
            UInt32[] outBuffer = new UInt32[3];
            int count = 0;

            outBuffer[0] = 0x00020faa;
            outBuffer[1] = 0x0a0b0c0d;

            Console.WriteLine("----------------------------------");
            Console.WriteLine("Single 32 bit data test");

            DHHalLib.SPIOpen(DHCOM_SPIEnum.DHCOM_SPI1);

            DHHalLib.SPIConfigure(DHCOM_SPIEnum.DHCOM_SPI1, DHCOM_SPIModeEnum.SPI_MODE0, freq, false);

            //if data bits less or equal then 32
            DHHalLib.SPIExchange(DHCOM_SPIEnum.DHCOM_SPI1, 24, outBuffer, inBuffer);

            Console.WriteLine("Data 0:" + string.Format("0x{0:X4}",inBuffer[0]));

            Console.WriteLine("----------------------------------");
            Console.WriteLine("Multiple 32 bit data test");

            //if data bits greater then 32
            DHHalLib.SPIExchange(DHCOM_SPIEnum.DHCOM_SPI1, 48, outBuffer, inBuffer);

            foreach (UInt32 d in inBuffer)
            {
                Console.WriteLine("Data " + count + ": " + string.Format("0x{0:X4}",d));
                count = count + 1;
            }

            DHHalLib.SPIClose(DHCOM_SPIEnum.DHCOM_SPI1);

            Console.WriteLine("----------------------------------");
        }
    }
}
