﻿using System;
using System.IO.Ports;
using System.Threading;
using System.Collections.Generic;
using System.ComponentModel;
using System.Linq;
using System.Text;

namespace CSharp_DHHalLib_Wrapper_App
{
    class UARTTest
    {
        public static void Testcode()
        {
            //Example Code from Microsoft
            /*SerialPort mySerialPort = new SerialPort("COM1");

            mySerialPort.BaudRate = 9600;
            mySerialPort.Parity = Parity.None;
            mySerialPort.StopBits = StopBits.One;
            mySerialPort.DataBits = 8;
            mySerialPort.Handshake = Handshake.None;
            mySerialPort.RtsEnable = true;

            mySerialPort.DataReceived += new SerialDataReceivedEventHandler(DataReceivedHandler);

            mySerialPort.Open();

            Console.WriteLine("Press any key to continue...");
            Console.WriteLine();
            Console.ReadKey();
            mySerialPort.Close();*/

            UART_YourCode();
            //UART_OurCode();
        }

        private static void UART_YourCode()
        {
            byte[] buffer = new byte[100];
            string result;

            //SerialPort rs232 = new SerialPort("COM2", 115200, Parity.None, 8, StopBits.One);
            SerialPort rs232 = new SerialPort("COM2:");

            rs232.BaudRate = 115200;
            rs232.Parity = Parity.None;
            rs232.DataBits = 8;
            rs232.StopBits = StopBits.One;
            rs232.Handshake = Handshake.None;
            rs232.ReadTimeout = 30000;
            rs232.WriteTimeout = 30000;

            //Must be set to wait for event
            rs232.ReadBufferSize = 25;
            rs232.WriteBufferSize = 25;

            try
            {
                rs232.Open();

                rs232.DiscardInBuffer();

                if (rs232.IsOpen == true)
                {
                    rs232.WriteLine("Teststring!");

                    rs232.DataReceived += new SerialDataReceivedEventHandler(DataReceivedHandler);
                    rs232.Read(buffer, 0, 25);

                    result = System.Text.Encoding.UTF8.GetString(buffer, 0, buffer.Length);
                    Console.WriteLine("UART Return Data: {0}", result);
                }
            }
            catch (Exception)
            {
                Console.WriteLine("Fehler beim Senden/Empfangen von UART Daten!");
            }
        }

        private static void DataReceivedHandler(object sender, SerialDataReceivedEventArgs e)
        {
            SerialPort sp = (SerialPort)sender;
            string indata = sp.ReadExisting();
            Console.WriteLine("Data Received:");
            Console.Write(indata);

            sp.Close();
        }
    }
}
